/*
 * Copyright (c) 2002 br1an <brian@innu.org>
 * All rights reserved.
 *
 * Official Stephanie homepage:
 *
 *	http://innu.org/~brian/Stephanie
 *
 * Shoutz go to shegget, S`, _eci, doe, jaf.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#ifndef __KERN_SNEEK_H
#define __KERN_SNEEK_H

#include <sys/param.h>
#include <sys/types.h>
#include <sys/exec.h>
#include <sys/proc.h>

#ifdef _KERNEL
	#include <sys/exec_script.h>
	#include <sys/systm.h>
	#include <sys/syslog.h>
	#include <sys/ucred.h>
#endif /* _KERNEL */

#define SNEEK_SET_ON		0x20
#define SNEEK_SET_OFF		0x40

#define SNEEK_LOG_ARGS		0x1
#define	SNEEK_LOG_UIDGID	0x2
#define SNEEK_LOG_PID		0x4
#define SNEEK_LOG_BG		0x8
#define SNEEK_LOG_ARGS_MAX	0x10
#define SNEEK_LOG_ALL		(SNEEK_LOG_ARGS | SNEEK_LOG_UIDGID | \
				SNEEK_LOG_PID | SNEEK_LOG_BG)

unsigned int sneek_flags;
unsigned int sneek_maxargs;

#define	SNEEK_ADD_FLAGS		1
#define	SNEEK_DEL_FLAGS		2
#define SNEEK_SET_FLAGS		3
#define	SNEEK_SHOW_FLAGS	4

#define SNEEK_FBITS \
"\020\1LOG_ARGS\2LOG_UIDGID\3LOG_PID\4LOG_BG\5LOG_ARGS_MAX"

#ifdef _KERNEL
void sneek_init(void);
void sneek_show(void);
void sneek_mode(int);
void sneek_log(struct proc *, struct exec_package, char * const *, int);
#endif /* _KERNEL */

#endif /* __KERN_SNEEK_H */
